from django.db import models
from django.utils.timezone import now

# Create your models here.

class Variable(models.Model):
    id = models.BigIntegerField(primary_key=True)

class RecordedData(models.Model):
    id = models.BigIntegerField(primary_key=True)
    date_saved = models.DateTimeField(blank=True, null=True, db_index=True)
    value_boolean = models.BooleanField(default=False, blank=True)  # boolean
    value_int16 = models.SmallIntegerField(null=True, blank=True)  # int16, uint8, int8
    value_int32 = models.IntegerField(
        null=True, blank=True
    )  # uint8, int16, uint16, int32
    value_int64 = models.BigIntegerField(null=True, blank=True)  # uint32, int64, int48
    value_float64 = models.FloatField(null=True, blank=True)  # float64, float48
    variable = models.ForeignKey(Variable, null=True, on_delete=models.SET_NULL)

class RecordedData2(models.Model):
    id = models.BigIntegerField(primary_key=True)
    date_saved = models.DateTimeField(blank=True, null=True, db_index=True)
    value_float64 = models.FloatField(null=True, blank=True)  # float64, float48
    variable = models.ForeignKey(Variable, null=True, on_delete=models.SET_NULL)

class RecordedData3(models.Model):
    id = models.BigIntegerField(primary_key=True)
    date_saved = models.DateTimeField(blank=True, null=True, db_index=True)
    value_float64 = models.FloatField(null=True, blank=True)
    value_str = models.CharField(null=True, blank=True, max_length=255)
    variable = models.ForeignKey(Variable, null=True, on_delete=models.SET_NULL)

class RecordedData4(models.Model):
    id = models.BigIntegerField(primary_key=True)
    date_saved = models.DateTimeField(default=now)
    value_float64 = models.FloatField(null=True, blank=True)
    value_str = models.CharField(null=True, blank=True, max_length=255)
    variable = models.ForeignKey(Variable, null=True, on_delete=models.SET_NULL)

    class Meta:
        indexes = [
            models.Index(fields=["date_saved"], name="date_saved_idx4"),
        ]

class RecordedData5(models.Model):
    id = models.BigIntegerField(primary_key=True)
    date_saved = models.DateTimeField(default=now)
    value_float64 = models.FloatField(null=True, blank=True)
    value_str = models.TextField(null=True, blank=True)
    variable = models.ForeignKey(Variable, null=True, on_delete=models.SET_NULL)

    class Meta:
        indexes = [
            models.Index(fields=["date_saved"], name="date_saved_idx5"),
        ]